Angular Pagination Component

Pagination

Documentation and examples for showing Angular pagination to indicate a series of related content exists across multiple pages.

Available in Other JavaScript Frameworks

CoreUI Angular Pagination Component is also available for Bootstrap, React, and Vue. Explore framework-specific implementations below:

Overview

We use a large block of connected links for our pagination, making links hard to miss and easily scalable—all while providing large hit areas. Pagination is built with list HTML elements so screen readers can announce the number of available links. Use a wrapping <nav> element to identify it as a navigation section to screen readers and other assistive technologies.

In addition, as pages likely have more than one such navigation section, it’s advisable to provide a descriptive aria-label for the <nav> to reflect its purpose. For example, if the pagination component is used to navigate between a set of search results, an appropriate label could be aria-label="Search results pages".

import { Component } from '@angular/core';
import { RouterLink } from '@angular/router';
import { PageItemDirective, PageLinkDirective, PaginationComponent } from '@coreui/angular';

@Component({
  selector: 'docs-pagination-overview',
  templateUrl: './pagination-overview.component.html',
  imports: [PaginationComponent, PageItemDirective, PageLinkDirective, RouterLink]
})
export class PaginationOverviewComponent {}
<c-pagination aria-label="Page navigation example">
  <li cPageItem>
    <a cPageLink [routerLink]>Previous</a>
  </li>
  <li cPageItem>
    <a cPageLink [routerLink]>1</a>
  </li>
  <li cPageItem>
    <a cPageLink [routerLink]>2</a>
  </li>
  <li cPageItem>
    <a cPageLink [routerLink]>3</a>
  </li>
  <li cPageItem>
    <a cPageLink [routerLink]>Next</a>
  </li>
</c-pagination>

Working with icons

Looking to use an icon or symbol in place of text for some pagination links? Be sure to provide proper screen reader support with aria attributes.

import { Component } from '@angular/core';
import { RouterLink } from '@angular/router';
import { PageItemDirective, PageLinkDirective, PaginationComponent } from '@coreui/angular';

@Component({
  selector: 'docs-pagination-working-with-icons',
  templateUrl: './pagination-working-with-icons.component.html',
  imports: [PaginationComponent, PageItemDirective, PageLinkDirective, RouterLink]
})
export class PaginationWorkingWithIconsComponent {}
<c-pagination aria-label="Page navigation example">
  <li cPageItem>
    <a cPageLink aria-label="Previous" [routerLink]><span aria-hidden="true">&laquo;</span></a>
  </li>
  <li cPageItem>
    <a cPageLink [routerLink]>1</a>
  </li>
  <li cPageItem>
    <a cPageLink [routerLink]>2</a>
  </li>
  <li cPageItem>
    <a cPageLink [routerLink]>3</a>
  </li>
  <li cPageItem>
    <a cPageLink aria-label="Next" [routerLink]><span aria-hidden="true">&raquo;</span></a>
  </li>
</c-pagination>

Disabled and active states

Pagination links are customizable for different circumstances. Use disabled for links that appear un-clickable and .active to indicate the current page.

While the disabled prop uses pointer-events: none to try to disable the link functionality of <a>s, that CSS property is not yet standardized and doesn’t account for keyboard navigation. As such, we always add tabindex="-1" on disabled links and use custom JavaScript to fully disable their functionality.

import { Component } from '@angular/core';
import { RouterLink } from '@angular/router';
import { PageItemDirective, PageLinkDirective, PaginationComponent } from '@coreui/angular';

@Component({
  selector: 'docs-pagination-disabled-active-states',
  templateUrl: './pagination-disabled-active-states.component.html',
  imports: [PaginationComponent, PageItemDirective, PageLinkDirective, RouterLink]
})
export class PaginationDisabledActiveStatesComponent {}
<c-pagination aria-label="Page navigation example">
  <li cPageItem [disabled]="true">
    <span cPageLink [routerLink]>Previous</span>
  </li>
  <li cPageItem>
    <a cPageLink [routerLink]>1</a>
  </li>
  <li cPageItem [active]="true">
    <span cPageLink [routerLink]>2</span>
  </li>
  <li cPageItem>
    <a cPageLink [routerLink]>3</a>
  </li>
  <li cPageItem>
    <a cPageLink [routerLink]>Next</a>
  </li>
</c-pagination>

You can optionally swap out active or disabled anchors for <span>, or omit the anchor in the case of the prev/next arrows, to remove click functionality and prevent keyboard focus while retaining intended styles.

import { Component } from '@angular/core';
import { RouterLink } from '@angular/router';
import { PageItemDirective, PageLinkDirective, PaginationComponent } from '@coreui/angular';

@Component({
  selector: 'docs-pagination-disabled-active-states-2',
  templateUrl: './pagination-disabled-active-states-2.component.html',
  imports: [PaginationComponent, PageItemDirective, PageLinkDirective, RouterLink]
})
export class PaginationDisabledActiveStates2Component {}
<c-pagination aria-label="Page navigation example">
  <li cPageItem [disabled]="true">
    <a cPageLink [routerLink]>Previous</a>
  </li>
  <li cPageItem>
    <a cPageLink [routerLink]>1</a>
  </li>
  <li cPageItem [active]="true">
    <a cPageLink [routerLink]>2</a>
  </li>
  <li cPageItem>
    <a cPageLink [routerLink]>3</a>
  </li>
  <li cPageItem>
    <a cPageLink [routerLink]>Next</a>
  </li>
</c-pagination>

Sizing

Fancy larger or smaller pagination? Add size="lg" or size="sm" for additional sizes.

import { Component } from '@angular/core';
import { RouterLink } from '@angular/router';
import { PageItemDirective, PageLinkDirective, PaginationComponent } from '@coreui/angular';

@Component({
  selector: 'docs-pagination-sizing-large',
  templateUrl: './pagination-sizing-large.component.html',
  imports: [PaginationComponent, PageItemDirective, PageLinkDirective, RouterLink]
})
export class PaginationSizingLargeComponent {}
<c-pagination aria-label="Page navigation example" size="lg">
  <li cPageItem [active]="true">
    <a cPageLink [routerLink]>Previous</a>
  </li>
  <li cPageItem>
    <a cPageLink [routerLink]>1</a>
  </li>
  <li cPageItem>
    <a cPageLink [routerLink]>2</a>
  </li>
  <li cPageItem>
    <a cPageLink [routerLink]>3</a>
  </li>
  <li cPageItem>
    <a cPageLink [routerLink]>Next</a>
  </li>
</c-pagination>
import { Component } from '@angular/core';
import { RouterLink } from '@angular/router';
import { PageItemDirective, PageLinkDirective, PaginationComponent } from '@coreui/angular';

@Component({
  selector: 'docs-pagination-sizing-small',
  templateUrl: './pagination-sizing-small.component.html',
  imports: [PaginationComponent, PageItemDirective, PageLinkDirective, RouterLink]
})
export class PaginationSizingSmallComponent {}
<c-pagination aria-label="Page navigation example" size="sm">
  <li cPageItem [active]="true">
    <a cPageLink [routerLink]>Previous</a>
  </li>
  <li cPageItem>
    <a cPageLink [routerLink]>1</a>
  </li>
  <li cPageItem>
    <a cPageLink [routerLink]>2</a>
  </li>
  <li cPageItem>
    <a cPageLink [routerLink]>3</a>
  </li>
  <li cPageItem>
    <a cPageLink [routerLink]>Next</a>
  </li>
</c-pagination>

Alignment

Change the alignment of pagination components with flexbox utilities.

import { Component } from '@angular/core';
import { RouterLink } from '@angular/router';
import { PageItemDirective, PageLinkDirective, PaginationComponent } from '@coreui/angular';

@Component({
  selector: 'docs-pagination-alignment',
  templateUrl: './pagination-alignment.component.html',
  imports: [PaginationComponent, PageItemDirective, PageLinkDirective, RouterLink]
})
export class PaginationAlignmentComponent {}
<c-pagination align="center" aria-label="Page navigation example">
  <li cPageItem [disabled]="true">
    <a cPageLink [routerLink]>Previous</a>
  </li>
  <li cPageItem>
    <a cPageLink [routerLink]>1</a>
  </li>
  <li cPageItem>
    <a cPageLink [routerLink]>2</a>
  </li>
  <li cPageItem>
    <a cPageLink [routerLink]>3</a>
  </li>
  <li cPageItem>
    <a cPageLink [routerLink]>Next</a>
  </li>
</c-pagination>
import { Component } from '@angular/core';
import { RouterLink } from '@angular/router';
import { PageItemDirective, PageLinkDirective, PaginationComponent } from '@coreui/angular';

@Component({
  selector: 'docs-pagination-alignment-2',
  templateUrl: './pagination-alignment-2.component.html',
  imports: [PaginationComponent, PageItemDirective, PageLinkDirective, RouterLink]
})
export class PaginationAlignment2Component {}
<c-pagination align="end" aria-label="Page navigation example">
  <li cPageItem [disabled]="true">
    <a cPageLink [routerLink]>Previous</a>
  </li>
  <li cPageItem>
    <a cPageLink [routerLink]>1</a>
  </li>
  <li cPageItem>
    <a cPageLink [routerLink]>2</a>
  </li>
  <li cPageItem>
    <a cPageLink [routerLink]>3</a>
  </li>
  <li cPageItem>
    <a cPageLink [routerLink]>Next</a>
  </li>
</c-pagination>

API

Pagination Module

import { PaginationModule } from '@coreui/angular';

@NgModule({
  imports: [PaginationModule,]
})
export class AppModule(){}

c-pagination

component

jsx
import { PaginationComponent } from '@coreui/angular'
PropertyDefaultType
align'''', 'start', 'center', 'end'

Set the alignment of pagination components.

role'navigation'string

Default role for pagination

size-'', 'sm', 'lg'

Size the component small or large.

c-page-item

component

jsx
import { PageItemComponent } from '@coreui/angular'
PropertyDefaultType
active-boolean

Toggle the active state for the component.

disabledfalseboolean

Toggle the disabled state for the component.

cPageItem

directive

jsx
import { PageItemDirective } from '@coreui/angular'
PropertyDefaultType
active-boolean

Toggle the active state for the component.

disabledfalseboolean

Toggle the disabled state for the component.

directive

jsx
import { PageLinkDirective } from '@coreui/angular'
PropertyDefaultType
disabledfalseboolean

Toggle the disabled state for the component.

Vue Pagination Component

Pagination

Documentation and examples for showing pagination to indicate a series of related content exists across multiple pages.

Available in Other JavaScript Frameworks

CoreUI Vue Pagination Component is also available for Angular, Bootstrap, and React. Explore framework-specific implementations below:

Overview

We use a large block of connected links for our pagination, making links hard to miss and easily scalable—all while providing large hit areas. Pagination is built with list HTML elements so screen readers can announce the number of available links. Use a wrapping <nav> element to identify it as a navigation section to screen readers and other assistive technologies.

In addition, as pages likely have more than one such navigation section, it’s advisable to provide a descriptive aria-label for the <nav> to reflect its purpose. For example, if the pagination component is used to navigate between a set of search results, an appropriate label could be aria-label="Search results pages".

vue
<template>
  <CPagination aria-label="Page navigation example">
    <CPaginationItem href="#">Previous</CPaginationItem>
    <CPaginationItem href="#">1</CPaginationItem>
    <CPaginationItem href="#">2</CPaginationItem>
    <CPaginationItem href="#">3</CPaginationItem>
    <CPaginationItem href="#">Next</CPaginationItem>
  </CPagination>
</template>

<script setup>
import { CPagination, CPaginationItem } from '@coreui/vue'
</script>

Working with icons

Looking to use an icon or symbol in place of text for some pagination links? Be sure to provide proper screen reader support with aria attributes.

vue
<template>
  <CPagination aria-label="Page navigation example">
    <CPaginationItem aria-label="Previous" href="#"
      ><span aria-hidden="true">&laquo;</span></CPaginationItem
    >
    <CPaginationItem href="#">1</CPaginationItem>
    <CPaginationItem href="#">2</CPaginationItem>
    <CPaginationItem href="#">3</CPaginationItem>
    <CPaginationItem aria-label="Next" href="#"
      ><span aria-hidden="true">&raquo;</span></CPaginationItem
    >
  </CPagination>
</template>

<script setup>
import { CPagination, CPaginationItem } from '@coreui/vue'
</script>

Disabled and active states

Pagination links are customizable for different circumstances. Use disabled for links that appear un-clickable and .active to indicate the current page.

While the disabled prop uses pointer-events: none to try to disable the link functionality of <a>s, that CSS property is not yet standardized and doesn’t account for keyboard navigation. As such, we always add tabindex="-1" on disabled links and use custom JavaScript to fully disable their functionality.

vue
<template>
  <CPagination aria-label="Page navigation example">
    <CPaginationItem aria-label="Previous" href="#" disabled
      ><span aria-hidden="true">&laquo;</span></CPaginationItem
    >
    <CPaginationItem href="#" active>1</CPaginationItem>
    <CPaginationItem href="#">2</CPaginationItem>
    <CPaginationItem href="#">3</CPaginationItem>
    <CPaginationItem aria-label="Next" href="#"
      ><span aria-hidden="true">&raquo;</span></CPaginationItem
    >
  </CPagination>
</template>

<script setup>
import { CPagination, CPaginationItem } from '@coreui/vue'
</script>

Sizing

Fancy larger or smaller pagination? Add size="lg" or size="sm" for additional sizes.

vue
<template>
  <CPagination size="lg" aria-label="Page navigation example">
    <CPaginationItem href="#">Previous</CPaginationItem>
    <CPaginationItem href="#">1</CPaginationItem>
    <CPaginationItem href="#">2</CPaginationItem>
    <CPaginationItem href="#">3</CPaginationItem>
    <CPaginationItem href="#">Next</CPaginationItem>
  </CPagination>
</template>

<script setup>
import { CPagination, CPaginationItem } from '@coreui/vue'
</script>
vue
<template>
  <CPagination size="sm" aria-label="Page navigation example">
    <CPaginationItem href="#">Previous</CPaginationItem>
    <CPaginationItem href="#">1</CPaginationItem>
    <CPaginationItem href="#">2</CPaginationItem>
    <CPaginationItem href="#">3</CPaginationItem>
    <CPaginationItem href="#">Next</CPaginationItem>
  </CPagination>
</template>

<script setup>
import { CPagination, CPaginationItem } from '@coreui/vue'
</script>

Alignment

Change the alignment of pagination components with align property.

vue
<template>
  <CPagination align="center" aria-label="Page navigation example">
    <CPaginationItem disabled>Previous</CPaginationItem>
    <CPaginationItem href="#">1</CPaginationItem>
    <CPaginationItem href="#">2</CPaginationItem>
    <CPaginationItem href="#">3</CPaginationItem>
    <CPaginationItem href="#">Next</CPaginationItem>
  </CPagination>
</template>

<script setup>
import { CPagination, CPaginationItem } from '@coreui/vue'
</script>
vue
<template>
  <CPagination align="end" aria-label="Page navigation example">
    <CPaginationItem disabled>Previous</CPaginationItem>
    <CPaginationItem href="#">1</CPaginationItem>
    <CPaginationItem href="#">2</CPaginationItem>
    <CPaginationItem href="#">3</CPaginationItem>
    <CPaginationItem href="#">Next</CPaginationItem>
  </CPagination>
</template>

<script setup>
import { CPagination, CPaginationItem } from '@coreui/vue'
</script>

React Pagination Component

Pagination

Documentation and examples for showing pagination to indicate a series of related content exists across multiple pages.

Available in Other JavaScript Frameworks

CoreUI React Pagination Component is also available for Angular, Bootstrap, and Vue. Explore framework-specific implementations below:

Overview

We use a large block of connected links for our pagination, making links hard to miss and easily scalable—all while providing large hit areas. Pagination is built with list HTML elements so screen readers can announce the number of available links. Use a wrapping <nav> element to identify it as a navigation section to screen readers and other assistive technologies.

In addition, as pages likely have more than one such navigation section, it’s advisable to provide a descriptive aria-label for the <nav> to reflect its purpose. For example, if the pagination component is used to navigate between a set of search results, an appropriate label could be aria-label="Search results pages".

import React from 'react'
import { CPagination, CPaginationItem } from '@coreui/react'

export const PaginationExample = () => {
  return (
    <CPagination aria-label="Page navigation example">
      <CPaginationItem>Previous</CPaginationItem>
      <CPaginationItem>1</CPaginationItem>
      <CPaginationItem>2</CPaginationItem>
      <CPaginationItem>3</CPaginationItem>
      <CPaginationItem>Next</CPaginationItem>
    </CPagination>
  )
}
import React from 'react'
import { CPagination, CPaginationItem } from '@coreui/react'

export const PaginationExample = () => {
  return (
    <CPagination aria-label="Page navigation example">
      <CPaginationItem>Previous</CPaginationItem>
      <CPaginationItem>1</CPaginationItem>
      <CPaginationItem>2</CPaginationItem>
      <CPaginationItem>3</CPaginationItem>
      <CPaginationItem>Next</CPaginationItem>
    </CPagination>
  )
}

Working with icons

Looking to use an icon or symbol in place of text for some pagination links? Be sure to provide proper screen reader support with aria attributes.

import React from 'react'
import { CPagination, CPaginationItem } from '@coreui/react'

export const PaginationWorkingWithIconsExample = () => {
  return (
    <CPagination aria-label="Page navigation example">
      <CPaginationItem aria-label="Previous">
        <span aria-hidden="true">&laquo;</span>
      </CPaginationItem>
      <CPaginationItem>1</CPaginationItem>
      <CPaginationItem>2</CPaginationItem>
      <CPaginationItem>3</CPaginationItem>
      <CPaginationItem aria-label="Next">
        <span aria-hidden="true">&raquo;</span>
      </CPaginationItem>
    </CPagination>
  )
}
import React from 'react'
import { CPagination, CPaginationItem } from '@coreui/react'

export const PaginationWorkingWithIconsExample = () => {
  return (
    <CPagination aria-label="Page navigation example">
      <CPaginationItem aria-label="Previous">
        <span aria-hidden="true">&laquo;</span>
      </CPaginationItem>
      <CPaginationItem>1</CPaginationItem>
      <CPaginationItem>2</CPaginationItem>
      <CPaginationItem>3</CPaginationItem>
      <CPaginationItem aria-label="Next">
        <span aria-hidden="true">&raquo;</span>
      </CPaginationItem>
    </CPagination>
  )
}

Disabled and active states

Pagination links are customizable for different circumstances. Use disabled for links that appear un-clickable and .active to indicate the current page.

While the disabled prop uses pointer-events: none to try to disable the link functionality of <a>s, that CSS property is not yet standardized and doesn’t account for keyboard navigation. As such, we always add tabindex="-1" on disabled links and use custom JavaScript to fully disable their functionality.

import React from 'react'
import { CPagination, CPaginationItem } from '@coreui/react'

export const PaginationDisabledAndActiveExample = () => {
  return (
    <CPagination aria-label="Page navigation example">
      <CPaginationItem aria-label="Previous" disabled>
        <span aria-hidden="true">&laquo;</span>
      </CPaginationItem>
      <CPaginationItem active>1</CPaginationItem>
      <CPaginationItem>2</CPaginationItem>
      <CPaginationItem>3</CPaginationItem>
      <CPaginationItem aria-label="Next">
        <span aria-hidden="true">&raquo;</span>
      </CPaginationItem>
    </CPagination>
  )
}
import React from 'react'
import { CPagination, CPaginationItem } from '@coreui/react'

export const PaginationDisabledAndActiveExample = () => {
  return (
    <CPagination aria-label="Page navigation example">
      <CPaginationItem aria-label="Previous" disabled>
        <span aria-hidden="true">&laquo;</span>
      </CPaginationItem>
      <CPaginationItem active>1</CPaginationItem>
      <CPaginationItem>2</CPaginationItem>
      <CPaginationItem>3</CPaginationItem>
      <CPaginationItem aria-label="Next">
        <span aria-hidden="true">&raquo;</span>
      </CPaginationItem>
    </CPagination>
  )
}

Sizing

Fancy larger or smaller pagination? Add size="lg" or size="sm" for additional sizes.

import React from 'react'
import { CPagination, CPaginationItem } from '@coreui/react'

export const PaginationSizingLargeExample = () => {
  return (
    <CPagination size="lg" aria-label="Page navigation example">
      <CPaginationItem>Previous</CPaginationItem>
      <CPaginationItem>1</CPaginationItem>
      <CPaginationItem>2</CPaginationItem>
      <CPaginationItem>3</CPaginationItem>
      <CPaginationItem>Next</CPaginationItem>
    </CPagination>
  )
}
import React from 'react'
import { CPagination, CPaginationItem } from '@coreui/react'

export const PaginationSizingLargeExample = () => {
  return (
    <CPagination size="lg" aria-label="Page navigation example">
      <CPaginationItem>Previous</CPaginationItem>
      <CPaginationItem>1</CPaginationItem>
      <CPaginationItem>2</CPaginationItem>
      <CPaginationItem>3</CPaginationItem>
      <CPaginationItem>Next</CPaginationItem>
    </CPagination>
  )
}
import React from 'react'
import { CPagination, CPaginationItem } from '@coreui/react'

export const PaginationSizingSmallExample = () => {
  return (
    <CPagination size="sm" aria-label="Page navigation example">
      <CPaginationItem>Previous</CPaginationItem>
      <CPaginationItem>1</CPaginationItem>
      <CPaginationItem>2</CPaginationItem>
      <CPaginationItem>3</CPaginationItem>
      <CPaginationItem>Next</CPaginationItem>
    </CPagination>
  )
}
import React from 'react'
import { CPagination, CPaginationItem } from '@coreui/react'

export const PaginationSizingSmallExample = () => {
  return (
    <CPagination size="sm" aria-label="Page navigation example">
      <CPaginationItem>Previous</CPaginationItem>
      <CPaginationItem>1</CPaginationItem>
      <CPaginationItem>2</CPaginationItem>
      <CPaginationItem>3</CPaginationItem>
      <CPaginationItem>Next</CPaginationItem>
    </CPagination>
  )
}

Alignment

Change the alignment of pagination components with align property.

import React from 'react'
import { CPagination, CPaginationItem } from '@coreui/react'

export const PaginationAlignmentExample = () => {
  return (
    <CPagination align="center" aria-label="Page navigation example">
      <CPaginationItem disabled>Previous</CPaginationItem>
      <CPaginationItem>1</CPaginationItem>
      <CPaginationItem>2</CPaginationItem>
      <CPaginationItem>3</CPaginationItem>
      <CPaginationItem>Next</CPaginationItem>
    </CPagination>
  )
}
import React from 'react'
import { CPagination, CPaginationItem } from '@coreui/react'

export const PaginationAlignmentExample = () => {
  return (
    <CPagination align="center" aria-label="Page navigation example">
      <CPaginationItem disabled>Previous</CPaginationItem>
      <CPaginationItem>1</CPaginationItem>
      <CPaginationItem>2</CPaginationItem>
      <CPaginationItem>3</CPaginationItem>
      <CPaginationItem>Next</CPaginationItem>
    </CPagination>
  )
}
import React from 'react'
import { CPagination, CPaginationItem } from '@coreui/react'

export const PaginationAlignment2Example = () => {
  return (
    <CPagination align="end" aria-label="Page navigation example">
      <CPaginationItem disabled>Previous</CPaginationItem>
      <CPaginationItem>1</CPaginationItem>
      <CPaginationItem>2</CPaginationItem>
      <CPaginationItem>3</CPaginationItem>
      <CPaginationItem>Next</CPaginationItem>
    </CPagination>
  )
}
import React from 'react'
import { CPagination, CPaginationItem } from '@coreui/react'

export const PaginationAlignment2Example = () => {
  return (
    <CPagination align="end" aria-label="Page navigation example">
      <CPaginationItem disabled>Previous</CPaginationItem>
      <CPaginationItem>1</CPaginationItem>
      <CPaginationItem>2</CPaginationItem>
      <CPaginationItem>3</CPaginationItem>
      <CPaginationItem>Next</CPaginationItem>
    </CPagination>
  )
}

API

Check out the documentation below for a comprehensive guide to all the props you can use with the components mentioned here.